/*
**Visual Basic true and false
*/
#define VbTRUE (-1)
#define VbFALSE (0)
/*
** Check if file exist. returns 0 if false
*/
Int16 EXPORT DIRexistFile(pInt8  fname);
/*
** Check if directory exist. returns 0 if false
*/
Int16 EXPORT DIRexistDir(pInt8  fname);
/*
** Split path, get the file name, returns 0 if bad
** assumes file of size 16
*/
Int16 EXPORT DIRsplitFile(pInt8  file,pInt8  path);
/*
** Split path, get the directory name, returns 0 if bad
** assumes Dir of size 128
*/
Int16 EXPORT DIRsplitDir(pInt8  direc,pInt8  path);
/*
** Split path, get the root file name, returns 0 if bad
** assumes root of size 16
*/
Int16 EXPORT DIRsplitRoot(pInt8  root,pInt8  path);
/*
** Make a complete path, from directory and file name
*/
Int16 EXPORT DIRmakePath(pInt8 path,pInt8  dir,pInt8  fname);

/*
** Start help file viewer
**  File = help file
**  Code = what to display
*/
Int16 EXPORT EXEChelpViewer(pInt8 File, Int32 Code);
/*
** Open a file, using the default Windows viewer associated
** to the file extension.
** return 0 if fail, or returns app handle
*/
Int16 EXPORT EXECopenFile(pInt8  File,pInt8 Params, pInt8  Dir);
/*
** Open a file, using the default Windows viewer associated
** to another file extension (provided as 3 Int8: "TXT")
** return 0 if fail, or returns app handle
*/
Int16 EXPORT EXECopenFileExt(pInt8  File,pInt8  Dir,pInt8  Ext);
/*
** Get byte, Int16 or Int32 at position pos, is string Str
** uses the big-endian ordering.
*/
Int16 EXPORT NUMgetChar(pInt8  Str,Int32 pos);
Int16 EXPORT NUMgetShort(pInt8  Str,Int32 pos);
Int32 EXPORT NUMgetLong(pInt8  Str,Int32 pos);


Int16 EXPORT DIRexistDrive(pInt8 Str, Int16 Len);

#if 0
' check if a file exists
Declare Function DIRexistFile% Lib "lbwintex.dll" (ByVal filenam$)
' check if a directory exists
Declare Function DIRexistDir% Lib "lbwintex.dll" (ByVal filenam$)
' split a path into: directory, full file name, root file name
' static direc as string * 128 : static  filnam as string * 16 : static root as string * 16
Declare Function DIRsplitDir% Lib "lbwintex.dll" (ByVal direc$, ByVal Path$)
Declare Function DIRsplitFile% Lib "lbwintex.dll" (ByVal filnam$, ByVal Path$)
Declare Function DIRsplitRoot% Lib "lbwintex.dll" (ByVal root$, ByVal Path$)
' make a path, for directory and file name
' static path as string * 128
Declare Function DIRmakePath% Lib "lbwintex.dll" (ByVal Path$, ByVal direc$, ByVal filenam$)
' Start a help file viewer
'  File = help file
'  Code = tag inside help file
Declare Function EXEChelpViewer% Lib "lbwintex.dll" (ByVal File$, ByVal Code&)
' Open a file, using the default Windows viewer associated
' to the file extension.
' return 0 if fail, or returns app handle
'
Declare Function EXECopenFile% Lib "lbwintex.dll" (ByVal file$, byVal Parms$, ByVal direc$)
' Open a file, using the default Windows viewer associated
' to another file extension (provided as 3 Int8: "TXT")
' return 0 if fail, or returns app handle
'
Declare Function EXECopenFileExt% Lib "lbwintex.dll" (ByVal file$, ByVal direc$, ByVal ext$)
' Get a Int8,Int16,Int32 at position pos in string s
'
Declare Function NUMgetChar% Lib "lbwintex.dll" (ByVal dta$, ByVal pos&)
Declare Function NUMgetShort% Lib "lbwintex.dll" (ByVal dta$, ByVal pos&)
Declare Function NUMgetLong& Lib "lbwintex.dll" (ByVal dta$, ByVal pos&)
#endif